<?php

// -----------------------------------------------
// Cryptographp v1.3
// (c) 2006 Sylvain BRISON 
//
// www.cryptographp.com 
// cryptographp@alphpa.com 
//
// Licence CeCILL (Voir Licence_CeCILL_V2-fr.txt)
// -----------------------------------------------


// -------------------------------------
// Configuration du fond du cryptogramme
// -------------------------------------


$cryptwidth  = $_SESSION["rdt_captcha"]["config"]["width"];  // Largeur du cryptogramme (en pixels)
$cryptheight = $_SESSION["rdt_captcha"]["config"]["height"];   // Hauteur du cryptogramme (en pixels)

$bgR  = $_SESSION["rdt_captcha"]["config"]["bgR"];         // Couleur du fond au format RGB: Red (0->255)
$bgG  = $_SESSION["rdt_captcha"]["config"]["bgG"];         // Couleur du fond au format RGB: Green (0->255)
$bgB  = $_SESSION["rdt_captcha"]["config"]["bgB"];         // Couleur du fond au format RGB: Blue (0->255)

$bgclear = $_SESSION["rdt_captcha"]["config"]["bgClear"];     // Fond transparent (true/false)
                     // Uniquement valable pour le format PNG

$bgimg = '';          // Le fond du cryptogramme peut-tre une image  
                             // PNG, GIF ou JPG. Indiquer le fichier image
                             // Exemple: $fondimage = 'photo.gif';
				                     // L'image sera redimensionne si ncessaire
                             // pour tenir dans le cryptogramme

$bgframe = $_SESSION["rdt_captcha"]["config"]["bgFrame"];    // Ajoute un cadre de l'image (true/false)


// ----------------------------
// Configuration des caractres
// ----------------------------

// Couleur de base des caractres

$charR = $_SESSION["rdt_captcha"]["config"]["charR"];     // Couleur des caractres au format RGB: Red (0->255)
$charG = $_SESSION["rdt_captcha"]["config"]["charG"];     // Couleur des caractres au format RGB: Green (0->255)
$charB = $_SESSION["rdt_captcha"]["config"]["charB"];     // Couleur des caractres au format RGB: Blue (0->255)

$charcolorrnd = $_SESSION["rdt_captcha"]["config"]["charcolorrnd"];      // Choix alatoire de la couleur.
$charcolorrndlevel = $_SESSION["rdt_captcha"]["config"]["charcolorrndlevel"];    // Niveau de clart des caractres si choix alatoire (0->4)
                           // 0: Aucune slection
                           // 1: Couleurs trs sombres (surtout pour les fonds clairs)
                           // 2: Couleurs sombres
                           // 3: Couleurs claires
                           // 4: Couleurs trs claires (surtout pour fonds sombres)

$charclear = $_SESSION["rdt_captcha"]["config"]["charclear"];   // Intensit de la transparence des caractres (0->127)
                  // 0=opaques; 127=invisibles
	                // interessant si vous utilisez une image $bgimg
	                // Uniquement si PHP >=3.2.1

// Polices de caractres

//$tfont[] = 'Alanden_';       // Les polices seront alatoirement utilises.
//$tfont[] = 'bsurp___';       // Vous devez copier les fichiers correspondants
//$tfont[] = 'ELECHA__.TTF';       // sur le serveur.
//$tfont[] = 'luggerbu.ttf';     // Ajoutez autant de lignes que vous voulez   
//$tfont[] = 'RASCAL__';     
//$tfont[] = 'SCRAWL.ttf';  
//$tfont[] = 'WAVY.ttf';

$tfont = $_SESSION["rdt_captcha"]["config"]["tfont"];



// Caracteres autoriss
// Attention, certaines polices ne distinguent pas (ou difficilement) les majuscules 
// et les minuscules. Certains caractres sont faciles  confondre, il est donc
// conseill de bien choisir les caractres utiliss.

$charel = $_SESSION["rdt_captcha"]["config"]["charel"];       // Caractres autoriss

$crypteasy = $_SESSION["rdt_captcha"]["config"]["crypteasy"];       // Cration de cryptogrammes "faciles  lire" (true/false)
                         // composs alternativement de consonnes et de voyelles.

$charelc = $_SESSION["rdt_captcha"]["config"]["charelc"];   // Consonnes utilises si $crypteasy = true
$charelv = $_SESSION["rdt_captcha"]["config"]["charelv"];              // Voyelles utilises si $crypteasy = true

$difuplow = $_SESSION["rdt_captcha"]["config"]["difuplow"];          // Diffrencie les Maj/Min lors de la saisie du code (true, false)

$charnbmin = $_SESSION["rdt_captcha"]["config"]["charnbmin"];         // Nb minimum de caracteres dans le cryptogramme
$charnbmax = $_SESSION["rdt_captcha"]["config"]["charnbmax"];         // Nb maximum de caracteres dans le cryptogramme

$charspace = $_SESSION["rdt_captcha"]["config"]["charspace"];        // Espace entre les caracteres (en pixels)
$charsizemin = $_SESSION["rdt_captcha"]["config"]["charsizemin"];      // Taille minimum des caractres
$charsizemax = $_SESSION["rdt_captcha"]["config"]["charsizemax"];      // Taille maximum des caractres

$charanglemax  = $_SESSION["rdt_captcha"]["config"]["charanglemax"];     // Angle maximum de rotation des caracteres (0-360)
$charup   = $_SESSION["rdt_captcha"]["config"]["charup"];      // Dplacement vertical alatoire des caractres (true/false)

// Effets supplmentaires

$cryptgaussianblur = false; // Transforme l'image finale en brouillant: mthode Gauss (true/false)
                            // uniquement si PHP >= 5.0.0
$cryptgrayscal = false;     // Transforme l'image finale en dgrad de gris (true/false)
                            // uniquement si PHP >= 5.0.0

// ----------------------
// Configuration du bruit
// ----------------------

$noisepxmin = $_SESSION["rdt_captcha"]["config"]["noisepxmin"];       // Bruit: Nb minimum de pixels alatoires
$noisepxmax = $_SESSION["rdt_captcha"]["config"]["noisepxmax"];       // Bruit: Nb maximum de pixels alatoires

$noiselinemin = $_SESSION["rdt_captcha"]["config"]["noiselinemin"];     // Bruit: Nb minimum de lignes alatoires
$noiselinemax = $_SESSION["rdt_captcha"]["config"]["noiselinemax"];     // Bruit: Nb maximum de lignes alatoires

$noisecolorchar  = $_SESSION["rdt_captcha"]["config"]["noisecolorchar"];  // Bruit: La couleur est celle du caractre (true) sinon celle du fond (false)


// --------------------------------
// Configuration systme & scurit
// --------------------------------

$cryptformat = $_SESSION["rdt_captcha"]["config"]["cryptformat"];   // Format du fichier image gnr "GIF", "PNG" ou "JPG"
				                // Si vous souhaitez un fond transparent, utilisez "PNG" (et non "GIF")
				                // Attention certaines versions de la bibliotheque GD ne gerent pas GIF !!!

$cryptsecure = $_SESSION["rdt_captcha"]["config"]["cryptsecure"];    // Mthode de crytpage utilise: "md5", "sha1" ou "" (aucune)
                      // "sha1" seulement si PHP>=4.2.0
                         // Si aucune mthode n'est indique, le code du cyptogramme est stock 
                         // en clair dans la session.
                       
$cryptusetimer = $_SESSION["rdt_captcha"]["config"]["cryptusetimer"];        // Temps (en seconde) avant d'avoir le droit de regnrer un cryptogramme
$cryptusertimererror = $_SESSION["rdt_captcha"]["config"]["cryptusertimererror"];  // Action  raliser si le temps minimum n'est pas respect:
                           // 1: Ne rien faire, ne pas renvoyer d'image.
                           // 2: L'image renvoye est "images/erreur2.png" (vous pouvez la modifier)
                           // 3: Le script se met en pause le temps correspondant (attention au timeout
                           //    par dfaut qui coupe les scripts PHP au bout de 30 secondes)
                           //    voir la variable "max_execution_time" de votre configuration PHP

$cryptusemax = $_SESSION["rdt_captcha"]["config"]["cryptusemax"];  // Nb maximum de fois que l'utilisateur peut gnrer le cryptogramme
                      // Si dpassement, l'image renvoye est "images/erreur1.png"
                      // PS: Par dfaut, la dure d'une session PHP est de 180 mn, sauf si 
                      // l'hebergeur ou le dveloppeur du site en on dcid autrement... 
                      // Cette limite est effective pour toute la dure de la session. 
?>
